/* CONFIG.H for PYTHON V1.5.2 on OpenVMS -- Uwe Zessin
     (some parts included from a port for PYTHON V1.2 that Donn Cave did)
     (no editing history for V1.3, V1.4B2, V1.4B3)
27-OCT-1996 ZE. -- Python V1.4
17-AUG-1997 ZE. -- preparation for utime() emulation in DCL environment
29-NOV-1997 ZE. -- merge with CONFIG.H_IN from Python V1.5B1
01-JAN-1998 ZE. -- merge with CONFIG.H_IN from Python V1.5
26-APR-1998 ZE. -- merge with CONFIG.H_IN from Python V1.5.1
21-DEC-1998 ZE. -- test THREADS
23-DEC-1998 ZE. -- merge with CONFIG.H_IN from Python V1.5.2B1
19-FEB-1999 ZE. -- merge with CONFIG.H_IN from Python V1.5.2B2
13-MAR-1999 ZE. -- try to determine if _DECC_V4_SOURCE should be set
09-APR-1999 ZE. -- merge with CONFIG.H_IN from Python V1.5.2C1
17-APR-1999 ZE. -- no changes for Python V1.5.2
25-AUG-1999 ZE. -- enable HAVE_EXECV for DEC C
31-OCT-1999 ZE. -- change platform from 'vms' to 'OpenVMS'
30-JAN-2000 ZE. -- updates for CVS snapshot from 25-JAN-2000
31-JAN-2000 ZE. -- added getlogin() emulation (in VMS__GETLOGIN.C)
04-JAN-2000 ZE. -- add feedback from Bruce Visscher for OpenVMS V7
			and OmniORB support
28-FEB-2000 ZE. -- add new C RTL features
30-APR-2000 ZE. -- updates for CVS snapshot from 10-APR-2000
08-MAY-2000 ZE. -- updates for CVS snapshot from 08-MAY-2000
27-MAY-2000 ZE. -- updates for CVS snapshot from 26-MAY-2000
20-JUL-2000 ZE. -- updates for CVS snapshot from 20-JUL-2000
04-AUG-2000 ZE. -- updates for CVS snapshot from 04-AUG-2000
*/

/*
	#if !defined(__CRTL_VER)
	#define __CRTL_VER 0
	#define __CRTL_VER_____REM 1
	#endif
*/

/* ---------------------------------------- */

#if __DECC_VER < 50200000 /* @@ might need to change for older version */
#define _DECC_V4_SOURCE 1
#endif

/* ---------------------------------------- */

/* #define WITH_THREAD    1 */
#ifdef WITH_THREAD
#define _POSIX_THREADS 1
#endif
#if __VMS_VER < 70000000
/* @@ it looks like PY_THREAD_D4 is gone (02-FEB-2000 ZE.) */
#define PY_THREAD_D4   1 /* both variants in */
#define PY_PTHREAD_D4  1 /* THREAD_PTHREAD.H */
#else
#define PY_THREAD_STD 1
#define PY_PTHREAD_STD
#endif

/* ---------------------------------------- */
#if !defined(__VMS_POSIX)
#include <unixio.h>	/* several routines need isatty(), close(),.. etc */
			/* on POSIX this is in stdlib.h */
int vms__ioctl (int __sd, int __request, char * __argp);
			/* no ioctl.h in VMS/DCL */
#endif

/* ---------------------------------------- */
/* Define if on AIX 3.
   System headers sometimes define this.
   We just want to avoid a redefinition error message.  */
#ifndef _ALL_SOURCE
/* #undef _ALL_SOURCE */
#endif

/* Define if type char is unsigned and you are not using gcc.  */
/* #undef __CHAR_UNSIGNED__ */

/* Define to empty if the keyword does not work.  */
/* #undef const */

/* readonly is a VAXC keyword.  This may require #undef readonly
   when including system headers. */
#define readonly pythrdonly

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef gid_t */

/* Define if your struct tm has tm_zone.  */
#if (__VMS_VER >= 70000000)
#define HAVE_TM_ZONE 1
#endif

/* Define if you don't have tm_zone but do have the external array
   tzname.  */
#if defined(__VMS_POSIX)
#define HAVE_TZNAME 1 /* @> POSIX$INCLUDE:TIME.H */
#endif

/* Define as __inline if that's what the C compiler calls it.  */
#undef inline

/* Define if on MINIX.  */
/* #undef _MINIX */

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef mode_t */

/* Define to `long' if <sys/types.h> doesn't define.  */
/* #undef off_t */

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef pid_t */

/* Define if the system does not provide POSIX.1 features except
   with this defined.  */
/* #undef _POSIX_1_SOURCE */

/* Define if you need to in order for stat and other things to work.  */
/* #undef _POSIX_SOURCE */

/* Define as the return type of signal handlers (int or void).  */
#define RETSIGTYPE void /* @@@ */

/* Define to `unsigned' if <sys/types.h> doesn't define.  */
/* #undef size_t */

/* Define if you have the ANSI C header files.  */
#define STDC_HEADERS 1

/* Define if you can safely include both <sys/time.h> and <time.h>.  */
#define TIME_WITH_SYS_TIME 1

/* Define if your <sys/time.h> declares struct tm.  */
#define TM_IN_SYS_TIME 1

/* Define to `int' if <sys/types.h> doesn't define.  */
/* #undef uid_t */

/* Define if your processor stores words with the most significant
   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
/* #undef WORDS_BIGENDIAN */

/* Define if your <unistd.h> contains bad prototypes for exec*()
   (as it does on SGI IRIX 4.x) */
/* #undef BAD_EXEC_PROTOTYPES */

/* Define if your compiler botches static forward declarations
   (as it does on SCI ODT 3.0) */
/* #define BAD_STATIC_FORWARD 1 */

/* Define for AIX if your compiler is a genuine IBM xlC/xlC_r
   and you want support for AIX C++ shared extension modules. */
#undef AIX_GENUINE_CPLUSPLUS

/* Define this if you have BeOS threads */
/* #undef BEOS_THREADS */

/* Define if you have the Mach cthreads package */
/* #undef C_THREADS */

/* Define to `long' if <time.h> doesn't define.  */
/* #undef clock_t */

/* Used for BeOS configuration */
/* #undef DL_EXPORT_HEADER */
/* #ifdef DL_EXPORT_HEADER */
/* #include DL_EXPORT_HEADER */
/* #endif */

/* Define if getpgrp() must be called as getpgrp(0). */
/* #define GETPGRP_HAVE_ARG 1 */

/* Define if gettimeofday() does not have second (timezone) argument
   This is the case on Motorola V4 (R40V4.2) */
/* -> hack for VMS has no TZ support, too */
/* @@ #define GETTIMEOFDAY_NO_TZ 1 */

/* Define if you have GNU PTH threads */
#undef _GNU_PTH

/* Define this if your time.h defines altzone */
/* #undef HAVE_ALTZONE */

/* Define this if you have gethostbyname() */
#define HAVE_GETHOSTBYNAME 1

/* Define this if you have some version of gethostbyname_r() */
/* #undef HAVE_GETHOSTBYNAME_R */

/* Define this if you have the 3-arg version of gethostbyname_r() */
/* #undef HAVE_GETHOSTBYNAME_R_3_ARG */

/* Define this if you have the 5-arg version of gethostbyname_r() */
/* #undef HAVE_GETHOSTBYNAME_R_5_ARG */

/* Define this if you have the 6-arg version of gethostbyname_r() */
/* #undef HAVE_GETHOSTBYNAME_R_6_ARG */

/* Define this if you have the type long long */
/* #undef HAVE_LONG_LONG */

/* Define if your compiler supports function prototypes */
#ifndef UNDEF_PROTO
#define HAVE_PROTOTYPES 1
#endif

/* Define if your compiler supports variable length function prototypes
   (e.g. void fprintf(FILE *, char *, ...);) *and* <stdarg.h> */
#define HAVE_STDARG_PROTOTYPES 1

/* Define if malloc(0) returns a NULL pointer */
/* #undef MALLOC_ZERO_RETURNS_NULL */

/* Define if you have POSIX threads */
/* #undef _POSIX_THREADS */ /* @@ not used on VMS */

/* Define to force use of thread-safe errno, h_errno, and other functions */
/* #undef _REENTRANT */ /* @@ need to check on VMS */

/* Define if setpgrp() must be called as setpgrp(0, 0). */
/* #define SETPGRP_HAVE_ARG 1 */

/* Define to empty if the keyword does not work.  */
/* #undef signed */

/* Define to `int' if <sys/types.h> doesn't define.  */
#if defined(_DECC_V4_SOURCE) /* @@ code moved from SOCKETMODULE.C */
#define socklen_t int
#else
#define socklen_t unsigned int
#endif

/* Define if  you can safely include both <sys/select.h> and <sys/time.h>
   (which you can't on SCO ODT 3.0). */
#define SYS_SELECT_WITH_SYS_TIME 1 /* @@ need to check on VMS */

/* Define if a va_list is an array of some kind */
/* #undef VA_LIST_IS_ARRAY */

/* Define to empty if the keyword does not work.  */
/* #undef volatile */

/* Define if you want SIGFPE handled (see Include/pyfpe.h). */
/* #undef WANT_SIGFPE_HANDLER * @@ need to check on VMS */

/* Define if the compiler provides a wchar.h header file. */
#define HAVE_WCHAR_H 1

/* Define if you have a useable wchar_t type defined in wchar.h; useable
   means wchar_t must be 16-bit unsigned type. (see
   Include/unicodeobject.h). */
#undef HAVE_USABLE_WCHAR_T /* @@ DEC-C = unsigned int ?? */

/* Define if you want wctype.h functions to be used instead of the
   one supplied by Python itself. (see Include/unicodectype.h). */
#undef WANT_WCTYPE_FUNCTIONS /* @@ ?? */

/* Define if you want to use SGI (IRIX 4) dynamic linking.
   This requires the "dl" library by Jack Jansen,
   ftp://ftp.cwi.nl/pub/dynload/dl-1.6.tar.Z.
   Don't bother on IRIX 5, it already has dynamic linking using SunOS
   style shared libraries */ 
/* #undef WITH_SGI_DL */

/* Define if you want to emulate SGI (IRIX 4) dynamic linking.
   This is rumoured to work on VAX (Ultrix), Sun3 (SunOS 3.4),
   Sequent Symmetry (Dynix), and Atari ST.
   This requires the "dl-dld" library,
   ftp://ftp.cwi.nl/pub/dynload/dl-dld-1.1.tar.Z,
   as well as the "GNU dld" library,
   ftp://ftp.cwi.nl/pub/dynload/dld-3.2.3.tar.Z.
   Don't bother on SunOS 4 or 5, they already have dynamic linking using
   shared libraries */
/* #undef WITH_DL_DLD */

/* Define if you want to use the new-style (Openstep, Rhapsody, MacOS)
   dynamic linker (dyld) instead of the old-style (NextStep) dynamic
   linker (rld). Dyld is necessary to support frameworks. */
/* #undef WITH_DYLD */

/* Define if you want to compile in rudimentary thread support */
/* #undef WITH_THREAD - @@ this is supplied by BLDRUN.COM or DCC_PYTHON.COM */

/* Define if you want to compile in cycle garbage collection */
#undef WITH_CYCLE_GC

/* Define if you want to produce an OpenStep/Rhapsody framework
   (shared library plus accessory files). */
/* #undef WITH_NEXT_FRAMEWORK */

/* The number of bytes in an off_t. */
#define SIZEOF_OFF_T 4

/* The number of bytes in a time_t. */
#define SIZEOF_TIME_T 4

/* Defined to enable large file support when an off_t is bigger than a long
   and long long is available and at least as big as an off_t. You may need
   to add some flags for configuration and compilation to enable this mode.
   E.g, for Solaris 2.7:
   CFLAGS="-D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64" OPT="-O2 $CFLAGS" \
 configure
*/
/* #undef HAVE_LARGEFILE_SUPPORT */

/* Defined when any dynamic module loading is enabled */
#undef HAVE_DYNAMIC_LOADING	/* @@ */

/* Define if i>>j for signed int i does not extend the sign bit
   when i < 0
*/
#undef SIGNED_RIGHT_SHIFT_ZERO_FILLS /* @@CVS20000720 */

/* The number of bytes in a char.  */
#undef SIZEOF_CHAR /* @@CVS20000410@@ */

/* The number of bytes in a double.  */
#undef SIZEOF_DOUBLE /* @@CVS20000410@@ */

/* The number of bytes in a float.  */
#undef SIZEOF_FLOAT /* @@CVS20000410@@ */

/* The number of bytes in a fpos_t.  */
#define SIZEOF_FPOS_T 4

/* The number of bytes in a int.  */
#define SIZEOF_INT 4

/* The number of bytes in a long.  */
#define SIZEOF_LONG 4

/* The number of bytes in a long long.  */
/* #undef SIZEOF_LONG_LONG */

/* The number of bytes in a void *.  */
#define SIZEOF_VOID_P 4

/* Define if you have the _getpty function.  */
#undef HAVE__GETPTY

/* Define if you have the alarm function.  */
#define HAVE_ALARM 1

/* Define if you have the chown function.  */
#define HAVE_CHOWN 1

/* Define if you have the clock function.  */
#define HAVE_CLOCK 1

/* Define if you have the confstr function.  */
#if __CRTL_VER >= 70000000 /* according to DEC C V6.0 <unistd.h> */
/* @@ #undef HAVE_CONFSTR */ /* -- not tested, yet */
#endif

/* Define if you have the ctermid function.  */
#define HAVE_CTERMID

/* Define if you have the ctermid_r function.  */
#ifdef __VMS_POSIX
#define HAVE_CTERMID_R 1
#endif

/* Define if you have the dlopen function.  */
/* #define HAVE_DLOPEN 1 */

/* Define if you have the dup2 function.  */
#define HAVE_DUP2 1

/* Define if you have the fdatasync function.  */
/* #undef HAVE_FDATASYNC */

/* Define if you have the flock function.  */
/* #undef HAVE_FLOCK */
/* @@ VMS POSIX has flockfile */

/* Define if you have the fork function.  */
/* VMS/DCL only has vfork() */
#ifdef __VMS_POSIX
#define HAVE_FORK 1
#endif

/* Define if you have the forkpty function.  */
#undef HAVE_FORKPTY

/* Define if you have the fpathconf function.  */
#if __CRTL_VER >= 70000000 /* according to DEC C V6.0 <unistd.h> */
/* @@ #undef HAVE_FPATHCONF */ /* -- not tested, yet */
#endif

/* Define if you have the fseek64 function.  */
/* #undef HAVE_FSEEK64 */

/* Define if you have the fseeko function.  */
/* #undef HAVE_FSEEKO */

/* Define if you have the fstatvfs function.  */
/* #undef HAVE_FSTATVFS */

/* Define if you have the fsync function.  */
#define HAVE_FSYNC 1

/* Define if you have the ftell64 function.  */
/* #undef HAVE_FTELL64 */

/* Define if you have the ftello function.  */
/* #undef HAVE_FTELLO */

/* Define if you have the ftime function.  */
#define HAVE_FTIME 1

/* Define if you have the ftruncate function.  */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_FTRUNCATE 1
#endif

/* Define if you have the getcwd function.  */
#define HAVE_GETCWD 1

/* Define if you have the getgroups function.  */
/* @@ #undef HAVE_GETGROUPS */

/* Define if you have the getlogin function.  */
#define HAVE_GETLOGIN 1
#ifndef __VMS_POSIX
char* vms__getlogin (void);
#define getlogin vms__getlogin	/* @@ emulation */
#endif

/* Define if you have the getpeername function.  */
#define HAVE_GETPEERNAME 1

/* Define if you have the getpgrp function.  */
#if defined(__VMS_POSIX)
#define HAVE_GETPGRP 1
#endif

/* Define if you have the getpid function.  */
#define HAVE_GETPID 1

/* Define if you have the getpwent function.  */
/* #undef HAVE_GETPWENT */

/* Define if you have the gettimeofday function.  */
/* #ifdef __CRTL_VER >= 70000000 ** @@ according to DEC C V6.0 */
#define HAVE_GETTIMEOFDAY 1	/* @@ VMS/DCL hack has part-of it */

/* Define if you have the getwd function.  */
/* #define HAVE_GETWD 1 */

/* Define if you have the hypot function.  */
#define HAVE_HYPOT 1

/* Define if you have the kill function.  */
#define HAVE_KILL 1

/* Define if you have the link function.  */
#if defined(__VMS_POSIX)
#define HAVE_LINK 1
#endif

/* Define if you have the lstat function.  */
#if defined(__VMS_POSIX)
#define HAVE_LSTAT 1
#endif

/* Define if you have the memmove function.  */
#define HAVE_MEMMOVE 1

/* Define if you have the mkfifo function.  */
#if defined(__VMS_POSIX)
#define HAVE_MKFIFO 1
#endif

/* Define if you have the mktime function.  */
#define HAVE_MKTIME 1

/* Define if you have the mremap function.  */
#undef HAVE_MREMAP

/* Define if you have the nice function.  */
#define HAVE_NICE 1

/* Define if you have the openpty function.  */
#undef HAVE_OPENPTY

/* Define if you have the pathconf function.  */
#if __CRTL_VER >= 70000000 /* according to DEC C V6.0 <unistd.h> */
/* @@ #undef HAVE_PATHCONF */ /* -- not tested, yet */
#endif

/* Define if you have the pause function.  */
#define HAVE_PAUSE 1

/* Define if you have the plock function.  */
/* #undef HAVE_PLOCK */

/* Define if you have the pthread_init function.  */
/* #undef HAVE_PTHREAD_INIT */
/* @@ not needed on OpenVMS - uses lib$initialize psects */

/* Define if you have the putenv function.  */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_PUTENV 1
#endif

/* Define if you have the readlink function.  */
#if defined(__VMS_POSIX)
#define HAVE_READLINK 1
#endif

/* Define if you have the rint function.  */
#ifdef __ALPHA
#define HAVE_RINT 1		/* <math.h> */
#endif

/* Define if you have the select function.  */
#if defined(__VMS_POSIX) || (__VMS_VER > 70000000)
#define HAVE_SELECT 1
#endif

/* Define if you have the setegid function.  */
#undef HAVE_SETEGID

/* Define if you have the seteuid function.  */
#undef HAVE_SETEUID

/* Define if you have the setgid function.  */
#if defined(__VMS_POSIX) || (__VMS_VER > 70000000)
#define HAVE_SETGID 1
#endif

/* Define if you have the setlocale function.  */
#define HAVE_SETLOCALE 1

/* Define if you have the setpgid function.  */
#if defined(__VMS_POSIX)
#define HAVE_SETPGID 1
#endif

/* Define if you have the setpgrp function.  */
/* #define HAVE_SETPGRP 1 */

/* Define if you have the setregid function.  */
#undef HAVE_SETREGID

/* Define if you have the setreuid function.  */
#undef HAVE_SETREUID

/* Define if you have the setsid function.  */
#if defined(__VMS_POSIX)
#define HAVE_SETSID 1
#endif

/* Define if you have the setuid function.  */
#if defined(__VMS_POSIX) || (__VMS_VER > 70000000)
#define HAVE_SETUID 1
#endif

/* Define if you have the setvbuf function.  */
#define HAVE_SETVBUF 1

/* Define if you have the sigaction function.  */
/* DCL: CMA$DEF.H ,POSIX: SIGNAL.H */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_SIGACTION 1
#endif

/* Define if you have the siginterrupt function.  */
/* #undef HAVE_SIGINTERRUPT */

/* Define if you have the sigrelse function.  */
/* #undef HAVE_SIGRELSE */

/* Define if you have the statvfs function.  */
/* #undef HAVE_STATVFS */

/* Define if you have the strdup function.  */
/* @@ DECC on Alpha should have it, too -- check */
#if defined(__VMS_POSIX) || (__VMS_VER > 70000000) /* @@ __CRTL_VER ? */
#define HAVE_STRDUP 1
#endif

/* Define if you have the strerror function.  */
#define HAVE_STRERROR 1

/* Define if you have the strftime function.  */
#define HAVE_STRFTIME 1

/* Define if you have the strptime function.  */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 60200000)
#define HAVE_STRPTIME 1
#endif

/* Define if you have the symlink function.  */
#if defined(__VMS_POSIX)
#define HAVE_SYMLINK 1
#endif

/* Define if you have the sysconf function.  */
#if __CRTL_VER >= 70000000 /* according to DEC C V6.0 <unistd.h> */
#define HAVE_SYSCONF 1
#endif

/* Define if you have the tcgetpgrp function.  */
#if defined(__VMS_POSIX)
#define HAVE_TCGETPGRP 1
#endif

/* Define if you have the tcsetpgrp function.  */
#if defined(__VMS_POSIX)
#define HAVE_TCSETPGRP 1
#endif

/* Define if you have the tempnam function.  */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_TEMPNAM 1
#endif

/* Define if you have the timegm function.  */
/* #undef HAVE_TIMEGM */

/* Define if you have the times function.  */
#define HAVE_TIMES 1
#define HZ 100 /* clock_t has 10millisecond granularity */

/* Define if you have the tmpfile function.  */
#define HAVE_TMPFILE 1

/* Define if you have the tmpnam function.  */
#define HAVE_TMPNAM 1

/* Define if you have the tmpnam_r function.  */
/* @@ #undef HAVE_TMPNAM_R */

/* Define if you have the truncate function.  */
#if (__CRTL_VER >= 70000000)
#define HAVE_TRUNCATE 1
#endif

/* Define if you have the uname function.  */
#define HAVE_UNAME 1
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
/* used builtin */
#else
/* #include "vms__utsname.h" */
#define uname vms__uname /* @@ emulation */
#endif

/* Define if you have the waitpid function.  */
#if defined(__VMS_POSIX) || (__VMS_VER >= 70000000) /* @@ might be too early */
#define HAVE_WAITPID 1
#endif

/* Define if you have the <dirent.h> header file.  */
/* #if defined(__VMS_POSIX) */
/* @@BV@@ #if defined(__VMS) && __VMS_VER >= 70000000 */
#define HAVE_DIRENT_H 1
/* #endif */

/* Define if you have the <dlfcn.h> header file.  */
/* #define HAVE_DLFCN_H 1 */

/* Define if you have the <fcntl.h> header file.  */
#if defined(__VMS_POSIX) || (__VMS_VER >= 70000000)
#define HAVE_FCNTL_H 1
#endif

/* Define if you have the <libutil.h> header file.  */
#undef HAVE_LIBUTIL_H

/* Define if you have the <limits.h> header file.  */
#define HAVE_LIMITS_H 1

/* Define if you have the <locale.h> header file.  */
#define HAVE_LOCALE_H 1

/* Define if you have the <ncurses.h> header file.  */
/* #undef HAVE_NCURSES_H */

/* Define if you have the <ndir.h> header file.  */
/* #undef HAVE_NDIR_H */

/* Define if you have the <pthread.h> header file.  */
/* @@ in SYS$LIBRARY: ! */
#define HAVE_PTHREAD_H 1

/* Define if you have the <pty.h> header file.  */
#undef HAVE_PTY_H

/* Define if you have the <signal.h> header file.  */
#define HAVE_SIGNAL_H 1

/* Define if you have the <stdarg.h> header file.  */
#define HAVE_STDARG_H 1

/* Define if you have the <stddef.h> header file.  */
#define HAVE_STDDEF_H 1

/* Define if you have the <stdlib.h> header file.  */
#define HAVE_STDLIB_H 1

/* Define if you have the <sys/audioio.h> header file.  */
/* #undef HAVE_SYS_AUDIOIO_H */

/* Define if you have the <sys/dir.h> header file.  */
/* #undef HAVE_SYS_DIR_H */

/* Define if you have the <sys/file.h> header file.  */
/* #undef HAVE_SYS_FILE_H */

/* Define if you have the <sys/lock.h> header file.  */
#undef HAVE_SYS_LOCK_H

/* Define if you have the <sys/ndir.h> header file.  */
/* #undef HAVE_SYS_NDIR_H */

/* Define if you have the <sys/param.h> header file.  */
/* #define HAVE_SYS_PARAM_H 1 */

/* Define if you have the <sys/select.h> header file.  */
/* #define HAVE_SYS_SELECT_H 1 */

/* Define if you have the <sys/socket.h> header file.  */
#undef HAVE_SYS_SOCKET_H

/* Define if you have the <sys/time.h> header file.  */
/* @? #define HAVE_SYS_TIME_H 1 */

/* Define if you have the <sys/times.h> header file.  */
#if defined(__VMS_POSIX) || (__VMS_VER >= 70000000)
#define HAVE_SYS_TIMES_H 1
#endif

/* Define if you have the <sys/un.h> header file.  */
/* #define HAVE_SYS_UN_H 1 */

/* Define if you have the <sys/utsname.h> header file.  */
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_SYS_UTSNAME_H 1
#endif

/* Define if you have the <sys/wait.h> header file.  */
#if defined(__VMS_POSIX) || (__VMS_VER >= 70000000)
#define HAVE_SYS_WAIT_H 1
#endif

/* Define if you have the <thread.h> header file.  */
/* #undef HAVE_THREAD_H */

/* Define if you have the <unistd.h> header file.  */
#define HAVE_UNISTD_H 1

/* Define if you have the <utime.h> header file.  */
/* @@ emulation in DCL environment available */
#define HAVE_UTIME_H 1

/* Define if you have the dl library (-ldl).  */
/* #undef HAVE_LIBDL */

/* Define if you have the dld library (-ldld).  */
/* #undef HAVE_LIBDLD */

/* Define if you have the ieee library (-lieee).  */
/* #undef HAVE_LIBIEEE */

/* ----- end of normal CONFIG.H ----- */

/* ---------------------------------------- */
/* addons for [.VMS]POSIXMODULE.C */
/* @@BV@@ #if defined(__VMS_POSIX) */
#if defined(__VMS_POSIX) || defined(__DECC)
#define HAVE_EXECV   1
#endif
/* HAVE_FORK already defined above */
/* HAVE_GETCWD " */
#define HAVE_GETEGID 1
#define HAVE_GETEUID 1
#define HAVE_GETGID  1
#define HAVE_GETPPID 1
#define HAVE_GETUID  1
/* HAVE_KILL already defined above */
#if __VMS_VER > 70000000 /* @@BV@@ */
#define HAVE_OPENDIR 1
#endif
#define HAVE_PIPE    1
#if defined(__VMS_POSIX) || (__CRTL_VER >= 70000000)
#define HAVE_POPEN   1
#endif
#define HAVE_SYSTEM  1
#define HAVE_WAIT    1
#define HAVE_TTYNAME 1

/* ---------------------------------------- */
/* info for GETCOMPILER.C */

#ifndef COMPILER
#ifdef __GNUC__
#define COMPILER " [GCC " __VERSION__ "]"
#endif
#endif /* !COMPILER */

#ifndef COMPILER
#ifdef __cplusplus
#ifdef __DECCXX
#define COMPILER "[DECC++]"
#else
#define COMPILER "[C++]"
#endif /* !__DECCXX */
#else
#ifdef __DECC
#define COMPILER "[DECC]"
#else
#if defined(__VAXC) || defined(VAXC)
#define COMPILER "[VAXC]"
#else
#define COMPILER "[C]"
#endif /* !(defined(__VAXC) || defined(VAXC)) */
#endif /* !__DECC */
#endif /* !__cplusplus */
#endif /* !COMPILER */

/* ---------- */
/* info for [.PYTHON]GETPLATFORM.C */

#ifndef PLATFORM
#ifdef __VMS_POSIX
#define PLATFORM "posix"
#else
#define PLATFORM "OpenVMS"
#endif /* !__VMS_POSIX */
#endif /* !PLATFORM */

/* ---------- */
/* for [.MODULES]GETPATH.C -> [.VMS]VMS__GETPATH.C if VMS/DCL */

#define VERSION "1_5_2"
#define PREFIX      "/PYTHON_DISK/PYTHON"
#define EXEC_PREFIX "/PYTHON_DISK/PYTHON"

/* #define PYTHONPATH "SYS$DISK:[]" */
#define PYTHONPATH "/PYTHON_LIBRARY"

/* ---------- */
/* for [.MODULES]GETBUILDINFO.C -> [.VMS]VMS__GETBUILDINFO.C if VMS/DCL */
/* #define BUILD 1 -- conflict with CPICKLE.C */

/* ---------------------------------------- */
/* Python V1.5.2B1 - needed for [.INCLUDE]MYMALLOC.H */

/* -- this copied from PYTHON.H */
/* config.h may or may not define DL_IMPORT */
#ifndef DL_IMPORT       /* declarations for DLL import/export */
#define DL_IMPORT(RTYPE) RTYPE
#endif
/* -- */

/* ---------------------------------------- */

/*#ifdef __CRTL_VER_____REM
#undef __CRTL_VER
#endif
*/

/* ---------------------------------------- */
/* names longer than 31 characters */
#define PyUnicode_DecodeRawUnicodeEscape   PyUnic_DecodeRawUnicodeEscape
#define PyUnicode_AsRawUnicodeEscapeString PyUnic_AsRawUnicodeEscapeString
#define PyUnicode_EncodeRawUnicodeEscape   PyUnic_EncodeRawUnicodeEscape
#define _PyUnicode_AsDefaultEncodedString  _PyUnic_AsDefaultEncodedString  
/* ---------------------------------------- */

/* EOF: CONFIG.H */
