/* PYVMS_GLOBAL.C -- global values -- 16-SEP-1997 Uwe Zessin

18-NOV-1997 ZE. -- add pyvms_gl_keyboard_id + pyvms_gl_key_table_id
19-NOV-1997 ZE. -- add pyvms_gar_rlbuffer
06-SEP-1998 ZE. -- add vmsdef_gl_itmtypsiz
01-NOV-1999 ZE. -- add vms_gr_utsname
23-FEB-2000 ZE. -- add global cells for builtin timezone support

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  PYVMS_GLOBAL

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module PYVMS_GLOBAL "20000223"
#endif

/* ------------------------------------------------------------------------- */
#include "vmsdef.h"
#include "pyvms_readline.h"
#include "vms__utsname.h"

/* ------------------------------------------------------------------------- */
#pragma extern_model strict_refdef
vmsdef_xw_vmsver vmsdef_gw_vmsver;			/* VMS version */

/* ------------------------------------------------------------------------- */
/* readline support */
long				  pyvms_gl_keyboard_id;		/* SMG$ */
long				  pyvms_gl_key_table_id;	/* SMG$ */
struct pyvms_xr_rlbuffer	* pyvms_gar_rlbuffer;		/* listhead */

/* ------------------------------------------------------------------------- */
/* flags for tracing */
long				pyvms_gl_trace_open;
long				pyvms_gl_trace_stat;

/* ------------------------------------------------------------------------- */
/* size of item types */
long	vmsdef_gl_itmtypsiz[] =
	{0	/* dummy entry */
	,0	/* ITMTYP_K_ASCII - string sizes handled by separate code */
	,0	/* ITMTYP_K_ASCIC - " */
	,1	/* ITMTYP_K_BYTE */
	,2	/* ITMTYP_K_WORD */
	,4	/* ITMTYP_K_LONG */
	,8	/* ITMTYP_K_QUAD */
	,16	/* ITMTYP_K_OCTA */
	,0	/* ITMTYP_K_BOOL - SYS$INIT_VOL() item-list */
	};

/* ------------------------------------------------------------------------- */
/* uname() support */

struct utsname	vms_gr_utsname;
char	      *	vms_gt_openvms = "OpenVMS";
char	      *	vms_gt_alpha   = "Alpha";	/* architectures */
char	      *	vms_gt_vax     = "VAX";

/* ------------------------------------------------------------------------- */
/* global cells for builtin timezone support */

char * vms_gat_tzname [2];	/* non-DST + DST name */
int    vms_gl_daylight;		/* 0 = DST is never in effect, 1 = yes */
long   vms_gl_timezone;		/* The difference, in seconds, between  */
				/* Universal Coordinated Time (UCT) and */

long   vms_gl_dst_offset;	/* difference between UTC and DST */

long   vms_gl_tzdiff;		/* lnm: SYS$TIMEZONE_DIFFERENTIAL */

/* ------------------------------------------------------------------------- */

/* EOF: PYVMS_GLOBAL.C */
