$!++
$! CVT_CONFIG_MODULES.COM -- 10-JAN-2000 - Uwe Zessin
$! 24-APR-2000 ZE. -- add key:2 "component"
$! 27-APR-2000 ZE. -- add data structure support for POSIX
$!
$! convert CONFIG_MODULES.TXT to indexed file CONFIG_MODULES.DAT
$! uses: PYTHON_TOOLS:CONFIG_MODULES.FDL
$!--
$ write SYS$OUTPUT F$FAO("!79*-")
$ if (P1 .eqs. "")
$ then
$   P1 = "PYTHON_VMS:CONFIG_MODULES.TXT"	! default
$   write SYS$ERROR "%CVT_CONFIG_MODULES-W-P1DEF, parameter 1 defaulted"
$   write SYS$ERROR " \",P1,"\"
$ endif
$!
$ if (P1 .eqs. "HELP")
$ then
$   goto SHOW_HELP
$ endif
$! ----------------------------------------
$ _DEFAULT = F$ENVIRONMENT("DEFAULT")
$ on ERROR then $ goto PROC_EXIT
$! ----------------------------------------------------------------------------
$ set DEFAULT PYTHON_VMS:
$!
$ _D = 0
$ close/nolog FIL_INP
$ close/nolog FIL_OUT
$!
$ T_DEV = F$PARSE(P1,,,"DEVICE")
$ T_DIR = F$PARSE(P1,,,"DIRECTORY")
$ T_NAM = F$PARSE(P1,,,"NAME")
$ T_TYP = F$PARSE(P1,,,"TYPE")
$ T_FIL_INP = P1
$ T_FIL_OUT = "[.TMP]"+ T_NAM+ ".TMP"
$!
$ _ALQ_INP = F$FILE_ATTRIBUTES(T_FIL_INP,"ALQ")	! pre-allocate .DAT file
$ _ALQ_OUT = _ALQ_INP
$ _ALQ_TMPTXT = _ALQ_INP * 4
$!
$ open/read  FIL_INP 'T_FIL_INP' ! 'P1'
$ copy /nolog _NLA0: /ALLOCATION='_ALQ_OUT' 'T_FIL_OUT'
$ open/append FIL_OUT 'T_FIL_OUT'
$ T_NOW = F$TIME()
$ T_DATE = F$CVTIME(T_NOW,"COMPARISON","YEAR")  + -
	   F$CVTIME(T_NOW,"COMPARISON","MONTH") + -
	   F$CVTIME(T_NOW,"COMPARISON","DAY")   !!!
$ DATA = F$FAO("!39AS|!39AS|!39AS|!AS|!AS|!AS|!3AS|!5AS|!5AS|!5AS|!5AS|!AS|", -
  "$CREATE", "AT:''T_NOW'", "BY:''F$EDIT(F$GETJPI(0,"USERNAME"),"COLLAPSE")'",-
  ".", ".", ".", ".", ".", ".", ".", ".", ".")
$ write /symbol FIL_OUT DATA
$!
$ L_INPUT_LINE  = 0
$ L_OUTPUT_LINE = 0
$!
$ T_COMPONENT = "PYTHON.BASE"
$ L_COMPONENT_COUNT = 0
$LOOP_CFGMOD:
$ read /END_OF_FILE=CFGMOD_EOF FIL_INP T_RECORD
$ L_INPUT_LINE = L_INPUT_LINE + 1
$ if _D then $ show symbol T_RECORD
$!
$ if (F$EXTRACT(0,12,T_RECORD) .eqs. "!$COMPONENT=")
$ then
$   T_RECORD = F$EDIT(T_RECORD,"COLLAPSE,UPCASE")
$   T_COMPONENT = F$ELEMENT(1,"=",T_RECORD)
$   write SYS$OUTPUT "%CVT_CONFIG_MODULES-I-COMPNAM, component: ", T_COMPONENT
$   L_COMPONENT_COUNT = L_COMPONENT_COUNT + 1
$   goto LOOP_CFGMOD				! next line
$ endif
$!
$ if (F$EXTRACT(0,1,T_RECORD) .eqs. "!")
$ then
$   goto LOOP_CFGMOD				! skip comment lines
$ endif
$ if (F$EDIT(T_RECORD,"COLLAPSE") .eqs. "")
$ then
$   goto LOOP_CFGMOD				! skip empty line
$ endif
$! -----
$ if (F$ELEMENT(0,"=",T_RECORD) .eqs. "$FORMAT_VERSION")
$ then
$   !@@ ignore for now
$   goto LOOP_CFGMOD
$ endif
$! -----
$ T_OLBNAM = F$ELEMENT(0,"|",T_RECORD)	! .OLB filename (VMS,PARSER,...)
$ T_MODULE = F$ELEMENT(1,"|",T_RECORD)	! module (VMS_SYS)
$ T_OLB    = F$ELEMENT(2,"|",T_RECORD)	! insert into .OLB (0/1)
$ T_DBG    = F$ELEMENT(3,"|",T_RECORD)	! debug flag (A,N,C)
$ T_THREAD = F$ELEMENT(4,"|",T_RECORD)	! thread only (T,-)
$ T_ENVCOM = F$ELEMENT(5,"|",T_RECORD)  ! Environment=Compiler
$ T_VER_A  = F$ELEMENT(6,"|",T_RECORD)	! OpenVMS Alpha version (06200)
$ if (F$LOCATE(",",T_VER_A) .eq. F$LENGTH(T_VER_A))
$ then
$   T_VER_AD = T_VER_A			! DCL
$   T_VER_AP = T_VER_A			! POSIX
$ else
$   T_VER_AD = F$ELEMENT(0,",",T_VER_A)
$   T_VER_AP = F$ELEMENT(1,",",T_VER_A)
$ endif
$ T_VER_V  = F$ELEMENT(7,"|",T_RECORD)	! OpenVMS VAX version   (06100)
$ if (F$LOCATE(",",T_VER_V) .eq. F$LENGTH(T_VER_V))
$ then
$   T_VER_VD = T_VER_V			! DCL
$   T_VER_VP = T_VER_V			! POSIX
$ else
$   T_VER_VD = F$ELEMENT(0,",",T_VER_V)
$   T_VER_VP = F$ELEMENT(1,",",T_VER_V)
$ endif
$ T_PROC   = F$ELEMENT(8,"|",T_RECORD)	! procedure (CC_PYTHON)
$ T_INCL   = F$ELEMENT(9,"|",T_RECORD)	! /INCLUDE=
$! -----
$ T_OLBNAM = F$EDIT(T_OLBNAM ,"COLLAPSE,UPCASE")
$ T_MODULE = F$EDIT(T_MODULE ,"COLLAPSE,UPCASE")
$ T_OLB    = F$EDIT(T_OLB    ,"COLLAPSE,UPCASE")
$ T_DBG    = F$EDIT(T_DBG    ,"COLLAPSE,UPCASE")
$ T_THREAD = F$EDIT(T_THREAD ,"COLLAPSE,UPCASE")
$!@@ T_VER_A  = F$EDIT(T_VER_A  ,"COLLAPSE")	! number only
$!@@ T_VER_V  = F$EDIT(T_VER_V  ,"COLLAPSE")	! number only
$ T_PROC   = F$EDIT(T_PROC   ,"COLLAPSE,UPCASE")
$!T_INCL   = !
$! T_COMPONENT (per default or separate '$!COMPOENENT=' line)
$! -----
$! @@checks:
$! if (f$type(T_VER_A) .nes. "NUMBER")
$! then
$!   write SYS$OUTPUT "input-line: ", L_INPUT_LINE, ", - Alpha-version not integer"
$!   goto LOOP_CFGMOD				! skip bad line
$! endif
$! -----
$ DATA = - !                                              max. 255 v---v
  F$FAO("!39AS|!39AS|!39AS|!1AS|!1AS|!1AS|!3AS|!5AS|!5AS|!5AS|!5AS|!AS|!AS|", -
  T_OLBNAM, T_MODULE, T_COMPONENT, T_OLB, T_DBG, T_THREAD, T_ENVCOM, -
  T_VER_AD, T_VER_AP, T_VER_VD, T_VER_VP, T_PROC, T_INCL)
$ write /symbol FIL_OUT DATA
$ L_OUTPUT_LINE = L_OUTPUT_LINE + 1
$ goto LOOP_CFGMOD				! next line
$! ----------------------------------------
$CFGMOD_EOF:
$ close FIL_INP
$ close FIL_OUT
$! -----
$ write SYS$ERROR "%CVT_CONFIG_MODULES-I-INPLIN, input lines.: ", L_INPUT_LINE
$ write SYS$ERROR "%CVT_CONFIG_MODULES-I-OUTLIN, output lines: ", L_OUTPUT_LINE
$ if (L_COMPONENT_COUNT .eq. 0)
$ then
$   L_COMPONENT_COUNT = 1	! default
$ endif
$ write SYS$ERROR "%CVT_CONFIG_MODULES-I-COMPCN, components..: ", L_COMPONENT_COUNT
$! -----
$! EDIT/FDL/SCRIPT=OPTIMIZE 
$ convert /statistics /FDL= PYTHON_TOOLS:CONFIG_MODULES.FDL	-
	'T_FIL_OUT' PYTHON_VMS:CONFIG_MODULES.DAT ! /EXCEPTIONS_FILE= PYTHON_VMS:CONFIG_MODULES.EXC		!
$ set FILE /VERSION_LIMIT=2 PYTHON_VMS:CONFIG_MODULES.DAT
$ if F$SEARCH("PYTHON_VMS:CONFIG_MODULES.EXC") .nes. ""
$ then
$   set FILE /VERSION_LIMIT=2 PYTHON_VMS:CONFIG_MODULES.EXC
$ endif
$ delete 'T_FIL_OUT';*
$! -----
$PROC_EXIT:
$ close /noLOG FIL_INP	! in case of error exit
$ close /noLOG FIL_OUT
$ exit 1
$! ----------------------------------------------------------------------------
$SHOW_HELP:
$ WRO = "write SYS$OUTPUT"
$ WRO ""
$ WRO " CVT_CONFIG_MODULES HELP"
$ WRO ""
$ WRO " Parameter 1: name of input file (e.g. CONFIG_MODULES.TXT)"
$ WRO ""
$ exit 1
