#++
# DEMO_EXTRACT.PY
#
# extract demo files from DEMO.TXT
# 17-NOV-1999 Uwe Zessin
#--

DEMO_FILE_NAME = "PYTHON_DOC_DEMO:DEMO.TXT"
DEB = 0

import fnmatch, string, sys

if (len (sys.argv) != 2):
  print "need filespec of files to extract from DEMO.TXT"
  sys.exit (1)
#

search_filename = sys.argv [1]          # P1
if (DEB):
  print '@@search_filename=',search_filename,'@@'

# -- read entire file into memory
if (DEB):
  print 'open input-file', DEMO_FILE_NAME, '...'

demo_inp_file  = open (DEMO_FILE_NAME, 'r')


while (1):
  demo_inp_line = demo_inp_file.readline()
  if (DEB):
    print '@@demo_inp_line=', demo_inp_line
  if (demo_inp_line == ''):
    break                               # EOF

  if ( (demo_inp_line[0:6] == '  #$% ') or \
       (demo_inp_line[0:8] == '  $!#$% ')  ):
    # found a marker - check filename
    if (demo_inp_line[0:6] == '  #$% '):
      demo_filename = demo_inp_line[6:]
    else:
      demo_filename = demo_inp_line[8:]
    demo_filename = demo_filename[:-1]	# strip trailing '\n'
    if (DEB):
      print '@@demo_filename=', demo_filename, '@@'
    # match filename
    if (fnmatch.fnmatch (demo_filename,search_filename)):
      # create output file
      print 'open output-file', demo_filename, '...'
      demo_out_file = open (demo_filename, 'w')
      # delete 2 characters from begin of line and write
      demo_out_file.write (demo_inp_line[2:])

      while (1):	# loop until end-marker, but skip pages
        demo_inp_line = demo_inp_file.readline()
        if (DEB):
          print '@@demo_inp_line=', repr(demo_inp_line)

        if (demo_inp_line == ''):
          break                                 # EOF

        if (demo_inp_line == '\f\n'):           # FF,CR
          # RUNOFF page break - skip it
          demo_inp_line = demo_inp_file.readline()
          demo_inp_line = demo_inp_file.readline()
          demo_inp_line = demo_inp_file.readline()
          demo_inp_line = demo_inp_file.readline()
        else:
          if ((demo_inp_line[0:5] == '  #%$') or \
	      (demo_inp_line[0:7] == '  $!#%$')  ):
            break
          else:
            if (demo_inp_line[0:2] == '  '):
              # delete 2 characters from begin of line and write
              demo_out_file.write (demo_inp_line[2:])
            else:
              demo_out_file.write (demo_inp_line)

      #-while

      demo_out_file.close()
      # search continues ...

# close input file (DEMO.TXT)
demo_inp_file.close()

# -- EOF: DEMO_EXTRACT.PY
