/* VMS__GETLOGIN.C -- 31-JAN-2000 -- Uwe Zessin

   getlogin() emulation for the DCL environment -- POSIXMODULE

   VMS POSIX has getlogin() in unistd.h
*/

#ifdef __DECC
#pragma module VMS__GETLOGIN "20000131"
#endif

/* ------------------------------------------------------------------------- */

#include <ctype.h>			/* tolower() */
#include <stdio.h>

#include <descrip.h>			/* string descriptors */
#include <jpidef.h>			/* JPI$_name */
#include <lib$routines.h>		/* LIB$name */
/* #include <ssdef.h>			/* SS$_name */

/* ------------------------------------------------------------------------- */

/* remember that |vms__getlogin()| returns a pointer to this - */
/*  it CANNOT live on the function stack!		       */

static char t_resultant_string[13];

/* ---------------------------------------- */

char* vms__getlogin (void)
{
	struct dsc$descriptor_s r_device_name;
	long				  l_item_code;
	long				  l_status;
	struct dsc$descriptor_s		  r_resultant_string;
				/* enough space for username (12)+ '\0' */
	char				* at_resultant_string;
	short int			  w_resultant_length;

	/* -------------------- */
	l_item_code = JPI$_USERNAME;

	/* set up string descriptor */
	r_resultant_string.dsc$w_length  =
		(sizeof(t_resultant_string) - 1); /* ommit '\0' at end */
	r_resultant_string.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_resultant_string.dsc$b_class   = DSC$K_CLASS_S;
	r_resultant_string.dsc$a_pointer = &t_resultant_string[0];

	l_status = lib$getjpi
		(&l_item_code
		,0			/* process-id      */
		,0			/* process-name    */
		,0			/* resultant_value */
		,&r_resultant_string, &w_resultant_length
		);
	/* @@ ignore errors */
	/* if (l_status == SS$_NORMAL) */
	{
	    t_resultant_string[w_resultant_length] = '\0';

	    /* remove any trailing spaces by replacing 1st one with '\0' */
	    at_resultant_string = &t_resultant_string[0];

	    while ((*at_resultant_string != ' ' ) &&
		   (*at_resultant_string != '\0')   )
	    {
		/* lowercase for compatibility with POSIX */
		*at_resultant_string = tolower (*at_resultant_string);
		at_resultant_string++;	/* skip non-blank */
	    }
	    *at_resultant_string = '\0';	/* terminate */

	    return (r_resultant_string.dsc$a_pointer);
	} /* (l_status == SS$_NORMAL) */
	/* @@ errno = ? */
	return NULL;

} /* char* vms__getlogin (void) */

/* ------------------------------------------------------------------------- */

/* EOF: VMS__GETLOGIN.C */
