/* VMS_LBR_DELETE_DATA.C -- 27-SEP-1999 Uwe Zessin
   Python interface to LBR$DELETE_DATA
*/

#ifdef __DECC
#pragma module VMS_LBR_DELETE_DATA "19991221"
#endif

#include "python.h"
#include "vmsdef.h"

/* ------------------------------------------------------------------------- */
extern PyObject *vms_lbr_gr_error;		/* exception vms_lbr.error */
/* ------------------------------------------------------------------------- */

/* ---------------------------------------- */
/* some DEC C versions are missing LBR$ROUTINES.H */
#ifdef __DECC
#ifndef __DECC_VER	/* don't know if this is defined in all versions ... */
#define __DECC_VER 0
#endif /* __DECC_VER */
#if (__DECC_VER < 60090001) /* @@ might need to change for older version */
#ifndef __unknown_params
#define __unknown_params ...
#endif
#pragma __nostandard	  /* non-ANSI-Standard feature */
unsigned long lbr$delete_data(__unknown_params);
#pragma __standard
#else
#include <lbr$routines.h>
#endif /* __DECC_VER < 60090001 */
#endif /* __DECC */

/* ------------------------------------------------------------------------- */

char vms_lbr_delete_data__doc[] =
"vms_lbr.delete_data (library_index, txtrfa)\n\
Delete a Module's Data.";

/* ---------------------------------------- */

PyObject *
vms_lbr_delete_data (PyObject *self, PyObject *args)
{
	unsigned long		  l_library_index;

	PyObject		* ar_txtrfa;
	unsigned long		  l_tuple_size;
	unsigned long		  l_tuple_index;
	unsigned long		  l_tuple_element;
	PyObject		* ar_tuple_element;
	unsigned long		  l_txtrfa[2];
	unsigned long		* al_txtrfa;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "lO",
	    &l_library_index,
	    &ar_txtrfa ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: library_index */

	/* -------------------- */
	/* argument 2: txtrfa */
	if (!PyTuple_Check(ar_txtrfa))
	{
	    PyErr_SetString(PyExc_TypeError,
		"argument 2: txtrfa - must be a tuple of 2 integers");
	    return NULL;
	}

	l_tuple_size = PyTuple_Size(ar_txtrfa);
	if (l_tuple_size != 2)
	{
	    PyErr_SetString(PyExc_TypeError,
		"argument 2: txtrfa - must be a tuple of 2 integers");
	    return NULL;
	}

	for (l_tuple_index = 0; l_tuple_index < 2; l_tuple_index++)
	{
	    ar_tuple_element = PyTuple_GetItem(ar_txtrfa, l_tuple_index);
	    if (ar_tuple_element == NULL)
	    {
		return NULL;
	    }
	    if (!PyInt_Check(ar_tuple_element))
	    {
		return PyErr_Format(PyExc_TypeError,
		   "argument 2: txtrfa - tuple-element:%d is not an integer",
		l_tuple_index);
	    }

	    l_tuple_element = PyInt_AsLong(ar_tuple_element);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }

	    l_txtrfa[l_tuple_index] = l_tuple_element;
	}

	/* -------------------- */
	l_status = lbr$delete_data
		(&l_library_index
		,&l_txtrfa
		);

	/* -------------------- */
#ifndef LBR$_NORMAL
#define LBR$_NORMAL 2523137
#endif
	if (l_status == LBR$_NORMAL)
	{
	    Py_INCREF (Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_lbr_gr_error, 1, l_status);
} /* vms_lbr_delete_data() */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LBR_DELETE_DATA.C */
