/* VMS_LBR_SET_INDEX.C -- 18-OCT-1999 Uwe Zessin
   Python interface to LBR$SET_INDEX
*/

#ifdef __DECC
#pragma module VMS_LBR_SET_INDEX "19991221"
#endif

#include "python.h"
#include "vmsdef.h"

/* ------------------------------------------------------------------------- */
extern PyObject *vms_lbr_gr_error;		/* exception vms_lbr.error */
/* ------------------------------------------------------------------------- */

/* ---------------------------------------- */
/* some DEC C versions are missing LBR$ROUTINES.H */
#ifdef __DECC
#ifndef __DECC_VER	/* don't know if this is defined in all versions ... */
#define __DECC_VER 0
#endif /* __DECC_VER */
#if (__DECC_VER < 60090001) /* @@ might need to change for older version */
#ifndef __unknown_params
#define __unknown_params ...
#endif
#pragma __nostandard	  /* non-ANSI-Standard feature */
unsigned long lbr$set_index(__unknown_params);
#pragma __standard
#else
#include <lbr$routines.h>
#endif /* __DECC_VER < 60090001 */
#endif /* __DECC */

/* ------------------------------------------------------------------------- */

char vms_lbr_set_index__doc[] =
"vms_lbr.set_index (library_index, index_number)\n\
Set the Current Index Number.";

/* ---------------------------------------- */

PyObject *
vms_lbr_set_index (PyObject *self, PyObject *args)
{
	unsigned long		  l_library_index;
	unsigned long		  l_index_number;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ll",
	    &l_library_index,
	    &l_index_number))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: library_index */

	/* -------------------- */
	/* argument 2: index_number */

	/* -------------------- */
	l_status = lbr$set_index
		(&l_library_index
		,&l_index_number
		);

	/* -------------------- */
	if (l_status == 2523137) /* LBR$_NORMAL */
	{
	    Py_INCREF (Py_None);
	    return Py_None;
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_lbr_gr_error, 1, l_status);
} /* vms_lbr_set_index() */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_LBR_SET_INDEX.C */
