/* VMS_SMG_CHANGE_PBD_CHARACTERISTICS.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CHANGE_PBD_CHARACTERISTICS

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CHANGE_PBD_CHARACTERISTICS

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CHANGE_PBD_CHARACTERIST "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_change_pbd_charact__doc[] =
"width, height, background_color\
 = vms_smg.change_pbd_characteristics\
 (pasteboard_id, [desired_width], [desired_height], [desired_background_color]\
)\n\
 Change Pasteboard Characteristics.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_change_pbd_characterist (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	PyObject		* ar_desired_width;
	unsigned long		  l_desired_width;
	unsigned long		* al_desired_width;

	unsigned long		  l_width;

	PyObject		* ar_desired_height;
	unsigned long		  l_desired_height;
	unsigned long		* al_desired_height;

	unsigned long		  l_height;

	PyObject		* ar_desired_background_color;
	unsigned long		  l_desired_background_color;
	unsigned long		* al_desired_background_color;

	unsigned long		  l_background_color;

	unsigned long		  l_status;

	/* -------------------- */
	ar_desired_width            = Py_None;
	ar_desired_height           = Py_None;
	ar_desired_background_color = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i|OOO"
	    ,&l_pasteboard_id
	    ,&ar_desired_width
	    ,&ar_desired_height
	    ,&ar_desired_background_color
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: [desired_width] */
	if (ar_desired_width == Py_None)
	{
	    al_desired_width = 0;		/* omitted */
	    l_desired_width  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_desired_width))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 2: desired_width - must be integer or None");
		return NULL;
	    }
	    l_desired_width = PyInt_AsLong(ar_desired_width);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_desired_width = &l_desired_width;
	}

	/* -------------------- */
	/* argument 3: [desired_height] */
	if (ar_desired_height == Py_None)
	{
	    al_desired_height = 0;		/* omitted */
	    l_desired_height  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_desired_height))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: desired_height - must be integer or None");
		return NULL;
	    }
	    l_desired_height = PyInt_AsLong(ar_desired_height);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_desired_height = &l_desired_height;
	}

	/* -------------------- */
	/* argument 4: [desired_background_color] */
	if (ar_desired_background_color == Py_None)
	{
	    al_desired_background_color = 0;		/* omitted */
	    l_desired_background_color  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_desired_background_color))
	    {
		PyErr_SetString(PyExc_TypeError,
	     "argument 4: desired_background_color - must be integer or None");
		return NULL;
	    }
	    l_desired_background_color = PyInt_AsLong(ar_desired_background_color);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_desired_background_color = &l_desired_background_color;
	}

	/* -------------------- */
	l_width            = 0;
	l_height           = 0;
	l_background_color = 0;

	/* -------------------- */
	l_status = smg$change_pbd_characteristics
		(&l_pasteboard_id
		,al_desired_width
		,&l_width
		,al_desired_height
		,&l_height
		,al_desired_background_color
		,&l_background_color
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("iii" ,l_width ,l_height ,l_background_color);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_change_pbd_characterist () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CHANGE_PBD_CHARACTERISTICS.C */
