/* VMS_SMG_CHECK_FOR_OCCLUSION.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CHECK_FOR_OCCLUSION

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CHECK_FOR_OCCLUSION

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CHECK_FOR_OCCLUSION "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_check_for_occlus__doc[] =
"status, occlusion_state =\
 vms_smg.check_for_occlusion (display_id, pasteboard_id)\n\
Check for Occlusion.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_check_for_occlusion (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;
	unsigned long		  l_pasteboard_id;

	long			  l_occlusion_state;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_display_id
	    ,&l_pasteboard_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */
	/* -------------------- */
	/* argument 2: pasteboard_id */

	/* -------------------- */
	l_occlusion_state = 0;

	/* -------------------- */
	l_status = smg$check_for_occlusion
		(&l_display_id
		,&l_pasteboard_id
		,&l_occlusion_state
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_NOTPASTED))
	{
	    return Py_BuildValue ("ii", l_status, l_occlusion_state);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_check_for_occlusion () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CHECK_FOR_OCCLUSION.C */
