/* VMS_SMG_CURSOR_COLUMN.C -- 05-MAR-2000 Uwe Zessin
   Python interface to SMG$CURSOR_COLUMN

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_CURSOR_COLUMN

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_CURSOR_COLUMN "20000305"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */

/* ------------------------------------------------------------------------- */

char vms_smg_cursor_column__doc[] =
"column_position = vms_smg.cursor_column (display_id)\n\
Return Cursor Column Position.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_cursor_column (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_cursor_column;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
/* @@ error conditions are signalled ! */
	l_cursor_column = smg$cursor_column (&l_display_id);

	/* -------------------- */
	return Py_BuildValue ("i", l_cursor_column);

} /* vms_smg_cursor_column () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_CURSOR_COLUMN.C */
