/* VMS_SMG_DISABLE_BROADCAST_TRAPPING.C -- 06-MAR-2000 Uwe Zessin
   Python interface to SMG$DISABLE_BROADCAST_TRAPPING

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_DISABLE_BROADCAST_TRAPPING

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_DISABLE_BRDCST_TRAPPING "20000306"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_dis_brdcst_trappng__doc [] =
"None = vms_smg.disable_broadcast_trapping (pasteboard_id)\n\
Disable Broadcast Trapping.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_disable_brdcst_trapping (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: l_pasteboard_id */

	/* -------------------- */
	l_status = smg$disable_broadcast_trapping (&l_pasteboard_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_disable_brdcst_trapping () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_DISABLE_BROADCAST_TRAPPING.C */
