/* VMS_SMG_ERASE_PASTEBOARD.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$ERASE_PASTEBOARD

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_ERASE_PASTEBOARD

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_ERASE_PASTEBOARD "20000309"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_erase_pasteboard__doc[] =
"status = vms_smg.erase_pasteboard (pasteboard_id)\n\
Erase Pasteboard.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_erase_pasteboard (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	l_status = smg$erase_pasteboard (&l_pasteboard_id);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_BATWAS_ON))
	{
	    return Py_BuildValue("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_erase_pasteboard () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_ERASE_PASTEBOARD.C */
