/* VMS_SMG_GET_BROADCAST_MESSAGE.C -- 09-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_BROADCAST_MESSAGE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_BROADCAST_MESSAGE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_GET_BROADCAST_MESSAGE "20000309"
#endif

/* ------------------------------------------------------------------------- */

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <lib$routines.h>	/* LIB$name  */
#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_broadcast_msg__doc[] =
"status, message, message_type =\
 vms_smg.get_broadcast_message (pasteboard_id)\n\
Get Broadcast Message.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_broadcast_message (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	struct dsc$descriptor_s   r_message;
	unsigned short		  w_message_length;

	unsigned short		  w_message_type;

	unsigned long		  l_status_smg;
	unsigned long		  l_status_free;

	PyObject		* ar_return;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* set up string descriptor */
	/*  let SMG$GET_BROADCAST_MESSAGE allocate the memory */
	r_message.dsc$w_length  = 0;
	r_message.dsc$b_dtype   = DSC$K_DTYPE_T;
	r_message.dsc$b_class   = DSC$K_CLASS_D; /* not _S !! */
	r_message.dsc$a_pointer = 0;
	w_message_length = 0;
	w_message_type   = 0;

	/* -------------------- */
	l_status_smg = smg$get_broadcast_message
		(&l_pasteboard_id
		,&r_message
		,&w_message_length
		,&w_message_type
		);

	/* -------------------- */
	if (
	    (l_status_smg == SS$_NORMAL)     ||
	    (l_status_smg == SMG$_NO_MORMSG) ||
	    (l_status_smg == SMG$_NONBRDMSG)
	   )
	{
	    PyObject	* ar_strobj;

	    ar_strobj = Py_BuildValue
		("s#"
		,(r_message.dsc$w_length == 0)	/* empty string? */
		  ? (void*)&r_message		/* non-NULL address */
		  : (void*)r_message.dsc$a_pointer
		,(unsigned int)r_message.dsc$w_length
		);
	    if (ar_strobj != NULL)
	    {
		ar_return = Py_BuildValue ("iOi"
			,l_status_smg
			,ar_strobj
			,(unsigned int)w_message_type
			);
		Py_DECREF(ar_strobj);
	    }
	    else
	    {
		ar_return = NULL;
	    }
	}
	else
	{
	    ar_return = NULL;
	}

	/* -------------------- */
	/* deallocate memory of dynamic string descriptor */
	l_status_free = lib$sfree1_dd (&r_message);
	if (l_status_free != SS$_NORMAL)
	{
	    PyErr_SetString(PyExc_SystemError,
		"vms_smg_get_broadcast_message: LIB$SFREE1_DD() failed");
	    (void) PyErr_Print();

	    if (l_status_smg == SS$_NORMAL)
	    {
		l_status_smg = l_status_free; /* fail anyway */
	        Py_XDECREF(ar_return);
	    }
	}

	/* -------------------- */
	if (
	    (l_status_smg == SS$_NORMAL)     ||
	    (l_status_smg == SMG$_NO_MORMSG) ||
	    (l_status_smg == SMG$_NONBRDMSG)
	   )
	{
	    return ar_return;
	}

	Py_XDECREF(ar_return);

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status_smg);
} /* vms_smg_get_broadcast_message () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_BROADCAST_MESSAGE.C */
