/* VMS_SMG_GET_CHAR_AT_PHYSICAL_CURSOR.C -- 20-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_CHAR_AT_PHYSICAL_CURSOR

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_CHAR_AT_PHYSICAL_CURSOR

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module vms_smg_get_char_at_phys_curs "20000320"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_char_at_phycur__doc[] =
"character_code = vms_smg.get_char_at_physical_cursor (pasteboard_id)\n\
 Return Character at Cursor.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_char_at_phys_curs (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	unsigned char		  b_character_code;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_pasteboard_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	l_status = smg$get_char_at_physical_cursor
		(&l_pasteboard_id
		,&b_character_code
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", (unsigned int)b_character_code);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_get_char_at_phys_curs () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_CHAR_AT_PHYSICAL_CURSOR.C */
