/* VMS_SMG_GET_DISPLAY_ATTR.C -- 20-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_DISPLAY_ATTR

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_DISPLAY_ATTR

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_GET_DISPLAY_ATTR "20000320"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_display_attr__doc[] =
"height, width, display_attributes, video_attributes, character_set, flags\
 = vms_smg.get_display_attr (display_id)\n\
The Get Display Attributes routine receives the attributes \
associated with a virtual display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_display_attr (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	long			  l_height;
	long			  l_width;
	unsigned long		  l_display_attributes;
	unsigned long		  l_video_attributes;
	unsigned long		  l_character_set;
	unsigned long		  l_flags;

	unsigned char		  b_character_code;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$get_display_attr
		(&l_display_id
		,&l_height
		,&l_width
		,&l_display_attributes
		,&l_video_attributes
		,&l_character_set
		,&l_flags
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("iiiiii"
		,l_height
		,l_width
		,l_display_attributes
		,l_video_attributes
		,l_character_set
		,l_flags
		);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_get_display_attr () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_DISPLAY_ATTR.C */
