/* VMS_SMG_GET_NUMERIC_DATA.C -- 21-MAR-2000 Uwe Zessin
   Python interface to SMG$GET_NUMERIC_DATA

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_GET_NUMERIC_DATA

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_GET_NUMERIC_DATA "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_get_numeric_data__doc[] =
"buffer \
 = vms_smg.get_numeric_data (termtable_address, request_code)\n\
Get Numeric Terminal Data.";

/* @@ constants for request codes are in $SMGTRMPTR */

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_get_numeric_data (PyObject *self, PyObject *args)
{
	unsigned long		  l_termtable_address;

	unsigned long		  l_request_code;
	unsigned long		  l_buffer;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii"
	    ,&l_termtable_address
	    ,&l_request_code
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: termtable_address */

	/* -------------------- */
	/* argument 2: request_code */

	/* -------------------- */
	l_status = smg$get_numeric_data
		(&l_termtable_address
		,&l_request_code
		,&l_buffer
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    return Py_BuildValue ("i", l_buffer);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_get_numeric_data () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_GET_NUMERIC_DATA.C */
