/* VMS_SMG_INVALIDATE_DISPLAY.C -- 21-MAR-2000 Uwe Zessin
   Python interface to SMG$INVALIDATE_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_INVALIDATE_DISPLAY

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_INVALIDATE_DISPLAY "20000321"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_invalidate_display__doc[] =
"None = vms_smg.invalidate_display (display_id)\n\
Mark a Display as Invalid.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_invalidate_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "i", &l_display_id))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	l_status = smg$invalidate_display (&l_display_id);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_invalidate_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_INVALIDATE_DISPLAY.C */
