/* VMS_SMG_PASTE_VIRTUAL_DISPLAY.C -- 22-MAR-2000 Uwe Zessin
   Python interface to SMG$PASTE_VIRTUAL_DISPLAY

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_PASTE_VIRTUAL_DISPLAY

02-JUL-2000 ZE. -- return status code, because when pasteboard is batched
		'%SMG-S-BATWAS_ON, batching was on' is returned, which did
		raise an exception, before.
*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_PASTE_VIRTUAL_DISPLAY "20000702"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name  */
#include <smgmsg.h>		/* SMG$_name */
#include <ssdef.h>		/* SS$_name  */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_paste_virtual_dpy__doc[] =
"status = vms_smg.paste_virtual_display (display_id, pasteboard_id,\
 [pasteboard_row], [pasteboard_column], [top_display_id])\n\
Paste Virtual Display.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_paste_virtual_display (PyObject *self, PyObject *args)
{
	unsigned long		  l_display_id;

	unsigned long		  l_pasteboard_id;

	PyObject		* ar_pasteboard_row;
	long			  l_pasteboard_row;
	long			* al_pasteboard_row;

	PyObject		* ar_pasteboard_column;
	long			  l_pasteboard_column;
	long			* al_pasteboard_column;

	PyObject		* ar_top_display_id;
	unsigned long		  l_top_display_id;
	unsigned long		* al_top_display_id;

	unsigned long		  l_status;

	/* -------------------- */
	ar_pasteboard_row    = Py_None;
	ar_pasteboard_column = Py_None;
	ar_top_display_id    = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii|OOO"
	    ,&l_display_id
	    ,&l_pasteboard_id
	    ,&ar_pasteboard_row
	    ,&ar_pasteboard_column
	    ,&ar_top_display_id
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: display_id */

	/* -------------------- */
	/* argument 2: pasteboard_id */

	/* -------------------- */
	/* argument 3: [pasteboard_row] */
	if (ar_pasteboard_row == Py_None)
	{
	    al_pasteboard_row = 0;		/* omitted */
	    l_pasteboard_row  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_pasteboard_row))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: pasteboard_row - must be integer or None");
		return NULL;
	    }
	    l_pasteboard_row = PyInt_AsLong(ar_pasteboard_row);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_pasteboard_row = &l_pasteboard_row;
	}

	/* -------------------- */
	/* argument 4: [pasteboard_column] */
	if (ar_pasteboard_column == Py_None)
	{
	    al_pasteboard_column = 0;		/* omitted */
	    l_pasteboard_column  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_pasteboard_column))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 4: pasteboard_column - must be integer or None");
		return NULL;
	    }
	    l_pasteboard_column = PyInt_AsLong(ar_pasteboard_column);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_pasteboard_column = &l_pasteboard_column;
	}

	/* -------------------- */
	/* argument 5: [top_display_id] */
	if (ar_top_display_id == Py_None)
	{
	    al_top_display_id = 0;		/* omitted */
	    l_top_display_id  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_top_display_id))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 5: top_display_id - must be integer or None");
		return NULL;
	    }
	    l_top_display_id = PyInt_AsLong(ar_top_display_id);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_top_display_id = &l_top_display_id;
	}

	/* -------------------- */
	l_status = smg$paste_virtual_display
		(&l_display_id
		,&l_pasteboard_id
		,al_pasteboard_row
		,al_pasteboard_column
		,al_top_display_id
		);

	/* -------------------- */
	if ((l_status == SS$_NORMAL) || (l_status == SMG$_BATWAS_ON))
	{
	    return Py_BuildValue ("i", l_status);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_paste_virtual_display () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_PASTE_VIRTUAL_DISPLAY.C */
