/* VMS_SMG_REPAINT_LINE.C -- 26-MAR-2000 Uwe Zessin
   Python interface to SMG$REPAINT_LINE

--------------------
$ @ PYTHON_VMS:BLDRUN  VMS  VMS_SMG_REPAINT_LINE

*/

#if defined(__DECC) || defined(__DECCXX)
#pragma module VMS_SMG_REPAINT_LINE "20000326"
#endif

/* ------------------------------------------------------------------------- */

#include "vmsdef.h"		/* includes "Python.h" */

#include <smg$routines.h>	/* SMG$name */
#include <ssdef.h>		/* SS$_name */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_smg_gr_error;		/* exception vms_smg.error */
/* ------------------------------------------------------------------------- */

char vms_smg_repaint_line__doc[] =
"None = vms_smg.repaint_line (pasteboard_id, start_row, [number_of_lines])\n\
Repaint One or More Lines on the Current Pasteboard.";

/* ------------------------------------------------------------------------- */

PyObject *
vms_smg_repaint_line (PyObject *self, PyObject *args)
{
	unsigned long		  l_pasteboard_id;

	long			  l_start_row;

	PyObject		* ar_number_of_lines;
	long			  l_number_of_lines;
	long			* al_number_of_lines;

	unsigned long		  l_status;

	/* -------------------- */
	ar_number_of_lines = Py_None;

	/* -------------------- */
	if (!PyArg_ParseTuple(args, "ii|O"
	    ,&l_pasteboard_id
	    ,&l_start_row
	    ,&ar_number_of_lines
	    ))
	{
	    return NULL;
	}

	/* -------------------- */
	/* argument 1: pasteboard_id */

	/* -------------------- */
	/* argument 2: start_row */

	/* -------------------- */
	/* argument 3: [number_of_lines] */
	if (ar_number_of_lines == Py_None)
	{
	    al_number_of_lines = 0;		/* omitted */
	    l_number_of_lines  = 0;
	}
	else
	{
	    if (!PyInt_Check(ar_number_of_lines))
	    {
		PyErr_SetString(PyExc_TypeError,
		    "argument 3: number_of_lines - must be integer or None");
		return NULL;
	    }
	    l_number_of_lines = PyInt_AsLong(ar_number_of_lines);
	    if (PyErr_Occurred())
	    {
		return NULL;
	    }
	    al_number_of_lines = &l_number_of_lines;
	}

	/* -------------------- */
	l_status = smg$repaint_line
		(&l_pasteboard_id
		,&l_start_row
		,al_number_of_lines
		);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    Py_INCREF(Py_None);
	    return (Py_None);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_smg_gr_error, 1, l_status);
} /* vms_smg_repaint_line () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SMG_REPAINT_LINE.C */
