/* VMS_SYS_GETUTC.C -- 16-JAN-2000 Uwe Zessin
   Python interface to SYS$GETUTC()

12-DEC-1997 ZE. -- created in VMS_SYS.C
16-JAN-2000 ZE. -- extract into VMS_SYS_GETUTC.C for V5.5-2 exclusion
*/

#ifdef __DECC
#pragma module VMS_SYS_GETUTC "20000116"
#endif

#include "python.h"
#include "vmsdef.h"

#include <descrip.h>
#include <ssdef.h>		/* SS$_name	 */
#include <starlet.h>		/* SYS$name, ... */

/* ------------------------------------------------------------------------- */
extern PyObject *vms_sys_gr_error;	/* in VMS_SYS.C */
/* ------------------------------------------------------------------------- */

/* input a binary octaword, output a Python long integer */
extern PyObject * vms__cvt_octa2pylong (long q_octaword[4]);

/* ------------------------------------------------------------------------- */

char vms_sys_getutc__doc[] =
"utcadr = vms_sys.getutc ()\n\
Get UTC Time.";

PyObject *
vms_sys_getutc (PyObject *self, PyObject *args)
{
	long		o_timadr[4];		/* utc_date_time */

	unsigned long	l_status;

	/* -------------------- */
	/* no arguments taken */
	if (!PyArg_ParseTuple(args, ""))
	{
	    return NULL;
	}

	/* -------------------- */
	l_status = sys$getutc (&o_timadr[0]);

	/* -------------------- */
	if (l_status == SS$_NORMAL)
	{
	    /* convert binary octaword to Python long integer */
	    return vms__cvt_octa2pylong (&o_timadr[0]);
	}

	/* -------------------- */
	/* error */
	return PyVMS_ErrSetVal(vms_sys_gr_error, 1, l_status);
} /* vms_sys_getutc () */

/* ------------------------------------------------------------------------- */

/* EOF: VMS_SYS_GETUTC.C */
